Index: libroar.ckport
===================================================================
--- libroar.ckport	(revision 5204)
+++ libroar.ckport	(revision 5400)
@@ -3,5 +3,5 @@
 !TYPE: func
 
-!TARGET: libroar0
+!TARGET: libroar2
 # Unsorted misc:
 roar_cdrom_run_cdparanoia	unknown
@@ -9,4 +9,6 @@
 roar_reset			wip	Do not use yet
 roar_panic_real			maybe	Mostly for internal use only.
+roar_fork			ok
+roar_libroar_set_forkapi	ok
 
 # Versions:
@@ -17,5 +19,7 @@
 roar_vio_clear_calls		ok
 
-roar_vio_close			ok
+roar_vio_close			removed
+roar_vio_ref			ok
+roar_vio_unref			ok
 
 roar_vio_read			ok
@@ -51,5 +55,5 @@
 # basic:
 roar_vio_open_fh		maybe
-roar_vio_open_file		maybe
+roar_vio_open_file		removed
 
 # network:
@@ -78,7 +82,7 @@
 
 # VIO internals:
-roar_vio_init_calls	internal
-roar_vio_set_inst	internal
-roar_vio_set_fh		legacy
+roar_vio_init_calls	removed
+roar_vio_set_inst	removed
+roar_vio_set_fh		removed
 roar_vio_get_fh		legacy
 
@@ -86,5 +90,5 @@
 roar_vio_basic_write	internal
 roar_vio_basic_lseek	internal
-roar_vio_basic_nonblock	internal
+roar_vio_basic_nonblock	removed
 roar_vio_basic_sync	internal
 roar_vio_basic_ctl	internal
@@ -97,5 +101,5 @@
 roar_vio_pass_write	internal
 roar_vio_pass_lseek	internal
-roar_vio_pass_nonblock	internal
+roar_vio_pass_nonblock	removed
 roar_vio_pass_sync	internal
 roar_vio_pass_ctl	internal
@@ -130,5 +134,5 @@
 roar_vio_buffer_write		internal
 roar_vio_buffer_lseek		internal
-roar_vio_buffer_nonblock	internal
+roar_vio_buffer_nonblock	removed
 roar_vio_buffer_sync		internal
 roar_vio_buffer_ctl		internal
@@ -140,5 +144,5 @@
 roar_vio_buffer_store_write	internal
 roar_vio_buffer_store_lseek	internal
-roar_vio_buffer_store_nonblock	internal
+roar_vio_buffer_store_nonblock	removed
 roar_vio_buffer_store_sync	internal
 roar_vio_buffer_store_ctl	internal
@@ -156,5 +160,5 @@
 roar_vio_cmd_read		internal
 roar_vio_cmd_write		internal
-roar_vio_cmd_nonblock		internal
+roar_vio_cmd_nonblock		removed
 roar_vio_cmd_sync		internal
 roar_vio_cmd_ctl		internal
@@ -194,5 +198,5 @@
 roar_vio_jumbo_write		internal
 roar_vio_jumbo_lseek		internal
-roar_vio_jumbo_nonblock		internal
+roar_vio_jumbo_nonblock		removed
 roar_vio_jumbo_sync		internal
 roar_vio_jumbo_ctl		internal
@@ -201,9 +205,9 @@
 # VIO Magic:
 roar_vio_open_magic		wip	Does not yet work
-roar_vio_magic_read		internal
-roar_vio_magic_write		internal
-roar_vio_magic_lseek		internal
-roar_vio_magic_nonblock		internal
-roar_vio_magic_sync		internal
+roar_vio_magic_read		removed
+roar_vio_magic_write		removed
+roar_vio_magic_lseek		removed
+roar_vio_magic_nonblock		removed
+roar_vio_magic_sync		removed
 roar_vio_magic_close		internal
 
@@ -214,5 +218,5 @@
 roar_vio_pipe_read		internal
 roar_vio_pipe_write		internal
-roar_vio_pipe_nonblock		internal
+roar_vio_pipe_nonblock		removed
 roar_vio_pipe_sync		internal
 roar_vio_pipe_ctl		internal
@@ -227,5 +231,5 @@
 roar_vio_proto_write		internal
 roar_vio_proto_lseek		internal
-roar_vio_proto_nonblock		internal
+roar_vio_proto_nonblock		removed
 roar_vio_proto_sync		internal
 roar_vio_proto_ctl		internal
@@ -243,5 +247,5 @@
 roar_vio_rtp_write		internal
 roar_vio_rtp_lseek		internal
-roar_vio_rtp_nonblock		internal
+roar_vio_rtp_nonblock		removed
 roar_vio_rtp_sync		internal
 roar_vio_rtp_ctl		internal
@@ -279,5 +283,5 @@
 roar_vio_stack_write		internal
 roar_vio_stack_lseek		internal
-roar_vio_stack_nonblock		internal
+roar_vio_stack_nonblock		removed
 roar_vio_stack_sync		internal
 roar_vio_stack_ctl		internal
@@ -291,5 +295,4 @@
 _vio_stream_ctl			internal
 _vio_stream_lseek		internal
-_vio_stream_nonblock		internal
 _vio_stream_read		internal
 _vio_stream_sync		internal
@@ -300,5 +303,5 @@
 roar_vio_misc_ctl		internal
 roar_vio_misc_lseek		internal
-roar_vio_misc_nonblock		internal
+roar_vio_misc_nonblock		removed
 roar_vio_misc_op_zero		internal
 roar_vio_misc_read		internal
@@ -321,5 +324,5 @@
 roar_vio_zlib_ctl		internal
 roar_vio_zlib_lseek		internal
-roar_vio_zlib_nonblock		internal
+roar_vio_zlib_nonblock		removed
 roar_vio_zlib_read		internal
 roar_vio_zlib_sync		internal
@@ -338,4 +341,5 @@
 roar_buffer_get_flag		ok
 roar_buffer_get_len		ok
+roar_buffer_get_datalen		ok
 roar_buffer_get_meta		ok
 roar_buffer_get_meta_i32	ok
@@ -356,5 +360,7 @@
 roar_buffer_set_offset		ok
 roar_buffer_shift_out		ok
-roar_buffer_clear_next		maybe	This indecates bad program design
+roar_buffer_clear_next		removed
+roar_buffer_moveinto		ok
+roar_buffer_next		ok
 roar_buffer_ref			ok
 roar_buffer_unref		ok
@@ -365,17 +371,19 @@
 # Some internal functions:
 roar_debug_msg			internal
-roar_debug_message_print	internal
-roar_debug_audio_info_print	internal
+roar_debug_message_print	removed
+roar_debug_audio_info_print	removed
 
 # Connection handling:
-roar_connect_raw		legacy	use roar_connect_raw2
-roar_connect_raw2		internal
+roar_connect_raw		removed
+roar_connect_raw2		removed
 roar_connect			ok
-roar_connect2			ok
+roar_connect2			removed	use roar_connect
 roar_connect_fh			likely
+roar_disconnect			removed	replaced by roar_connectionunref
+roar_connectionref		ok
+roar_connectionunref		ok
 roar_get_connection_fh		critical
-roar_get_connection_vio		legacy	use roar_get_connection_vio2
+roar_get_connection_vio		removed	use roar_get_connection_vio2
 roar_get_connection_vio2	ok
-roar_disconnect			ok
 roar_set_connection_callback	wip
 roar_sync			ok
@@ -406,5 +414,5 @@
 # Streams:
 roar_stream_connect		ok
-roar_stream_connect2		ok
+roar_stream_connect2		removed	use roar_stream_connect
 roar_stream_new			ok
 roar_stream_set_rel_id		ok
@@ -425,7 +433,7 @@
 
 roar_stream_attach_simple	ok
-roar_stream_add_data		likely	does not work most of the time
-
-roar_stream_send_data		critical	does not work as expected
+roar_stream_add_data		removed	does not work most of the time
+
+roar_stream_send_data		removed
 
 roar_stream_get_info		ok
@@ -435,6 +443,6 @@
 roar_stream_set_chanmap		wip
 
-roar_stream_set_flags		legacy	Use roar_stream_set_flags2
-roar_stream_set_flags2		ok
+roar_stream_set_flags		ok
+roar_stream_set_flags2		removed	Use roar_stream_set_flags
 roar_stream_set_role		ok
 
@@ -496,8 +504,8 @@
 roar_get_standby		ok
 roar_set_standby		ok
-roar_exit			legacy	use roar_terminate
+roar_exit			removed	use roar_terminate
 roar_terminate			ok
-roar_server_oinfo		legacy	depends on mixer
-roar_server_oinfo2		ok
+roar_server_oinfo		ok
+roar_server_oinfo2		removed	use roar_server_oinfo
 
 roar_list			ok
@@ -510,5 +518,5 @@
 
 roar_set_vol			ok
-roar_set_vol2			ok
+roar_set_vol2			removed	use roar_set_vol
 roar_get_vol			ok
 
@@ -532,9 +540,9 @@
 # File handlung:
 roar_file_codecdetect		ok
-roar_file_send_raw		legacy	use roar_vio_copy_data
-roar_file_play			ok
-roar_file_play_full		ok
-roar_file_map			likely	not supported on all systems
-roar_file_unmap			likely	not supported on all systems
+roar_file_send_raw		removed	use roar_vio_copy_data
+roar_file_play			removed	use roar_simple_play_file
+roar_file_play_full		removed	use roar_simple_play_file
+roar_file_map			removed
+roar_file_unmap			removed
 
 roar_cdromdevice		maybe
@@ -592,10 +600,10 @@
 
 # Error handling:
-roar_err_int			legacy	Use roar_err_init
+roar_err_int			removed	Use roar_err_init
 roar_err_init			ok
-roar_err_buildmsg		legacy	Use roar_err_buildmsg2
-roar_err_buildmsg2		wip
-roar_err_parsemsg		legacy	Use roar_err_parsemsg2
-roar_err_parsemsg2		wip
+roar_err_buildmsg		ok
+roar_err_buildmsg2		removed Use roar_err_buildmsg
+roar_err_parsemsg		ok
+roar_err_parsemsg2		removed Use roar_err_parsemsg
 
 roar_err_to_errno		maybe	This function should be avoided outside of libroar*
@@ -605,5 +613,5 @@
 roar_err_clear_all		maybe	This function should be avoided outside of libroar*
 
-roar_err_is_errno_clean		legacy	Use roar_err_is_errno_clear
+roar_err_is_errno_clean		removed	Use roar_err_is_errno_clear
 roar_err_is_errno_clear		likely	This function should be avoided outside of libroar*
 
@@ -614,8 +622,10 @@
 roar_err_errorframe		ok
 
+roar_err_initstore		ok
 roar_err_restore		ok
 roar_err_store			ok
 
 roar_error2str			ok
+roar_error2str_ms		internal
 
 # Trap API:
@@ -688,8 +698,20 @@
 # RoarDL:
 roar_dl_open			ok
-roar_dl_close			ok
+roar_dl_close			removed	use roar_dl_unref
+roar_dl_ref			ok
+roar_dl_unref			ok
 roar_dl_getsym			ok
 roar_dl_ra_init			ok
 roar_dl_errstr			ok
+roar_dl_getlibname		ok
+roar_dl_getpara			ok
+roar_dl_context_restore		ok
+roar_dl_context_store		ok
+roar_dl_appsched_trigger	ok
+
+roar_dl_para_new		ok
+roar_dl_para_ref		ok
+roar_dl_para_unref		ok
+roar_dl_para_check_version	ok
 
 _roardl2ldl			internal
@@ -716,23 +738,23 @@
 roar_simple_connect2		ok
 
-roar_simple_stream		legacy	use VIO based streams
-roar_simple_stream_obj		legacy	use VIO based streams
+roar_simple_stream		removed	use VIO based streams
+roar_simple_stream_obj		removed	use VIO based streams
 roar_simple_new_stream_attachexeced_obj	internal
 
-roar_simple_new_stream		legacy
-roar_simple_new_stream_obj	legacy
+roar_simple_new_stream		removed
+roar_simple_new_stream_obj	removed
 
 roar_simple_play_file		ok
 
-roar_simple_play		legacy
-roar_simple_monitor		legacy
-roar_simple_record		legacy
-roar_simple_filter		legacy
+roar_simple_play		removed	use roar_vs_new_simple
+roar_simple_monitor		removed	use roar_vs_new_simple
+roar_simple_record		removed	use roar_vs_new_simple
+roar_simple_filter		removed	use roar_vs_new_simple
 
 roar_simple_connect_virtual	ok
 
-roar_simple_close		legacy	use roar_vio_close
-
-roar_simple_get_standby		legacy	use roar_get_standby
+roar_simple_close		removed	use roar_vio_close
+
+roar_simple_get_standby		removed	use roar_get_standby
 
 # (old) Socket API:
@@ -740,24 +762,24 @@
 roar_socket_connect		legacy	use roar_vio_open_socket
 
-roar_socket_new_tcp		internal
-roar_socket_new_udp		internal
-roar_socket_new_tcp6		internal
-roar_socket_new_udp6		internal
-roar_socket_new_unix		internal
-roar_socket_new_decnet_seqpacket	internal
-roar_socket_new_decnet_stream	internal
-roar_socket_new_ipxspx		internal
-roar_socket_new_ipx		internal
+roar_socket_new_tcp		removed
+roar_socket_new_udp		removed
+roar_socket_new_tcp6		removed
+roar_socket_new_udp6		removed
+roar_socket_new_unix		removed
+roar_socket_new_decnet_seqpacket	removed
+roar_socket_new_decnet_stream	removed
+roar_socket_new_ipxspx		removed
+roar_socket_new_ipx		removed
 
 roar_socket_open		legacy	use roar_vio_open_socket or roar_vio_open_socket_listen
-roar_socket_open_fork		internal
-roar_socket_open_file		internal
-roar_socket_open_proxy		internal
-roar_socket_listen_decnet	internal
+roar_socket_open_fork		removed
+roar_socket_open_file		removed
+roar_socket_open_proxy		removed
+roar_socket_listen_decnet	removed
 roar_socket_get_local_nodename	internal
 roar_socket_nonblock		internal	use roar_vio_nonblock
-roar_socket_decnet_set_timeout	internal
-roar_socket_recvbuf		internal
-roar_socket_set_tos		internal
+roar_socket_decnet_set_timeout	removed
+roar_socket_recvbuf		removed
+roar_socket_set_tos		removed
 roar_socket_dup_udp_local_end	internal
 
@@ -801,5 +823,5 @@
 roar_vs_position		ok
 roar_vs_latency			ok
-roar_vs_latency2		ok
+roar_vs_latency2		removed	use roar_vs_latency
 roar_vs_init			internal
 roar_vs_strerr			ok
@@ -873,4 +895,5 @@
 # general server info:
 roar_server_info		ok
+roar_library_info		ok
 roar_server_info_free		ok
 roar_server_info_from_mes	likely	This is for internal use mostly